-- doxygen_example.vhdl

library ieee;
use     ieee.std_logic_1164.all;

library my_design_lib; --! Design components library

--! Top level
entity my_top_level is

    port
    (

        --! Port A
        PORT_A                  : in    std_logic;

        --! Port B
        PORT_B                  : in    std_logic;

        --! Port C
        PORT_C                  : in    std_logic;

        --! Port D
        PORT_D                  : in    std_logic;

        --! Port E
        PORT_E                  : out   std_logic;

        --! Port F
        PORT_F                  : out   std_logic

    );

end my_top_level;


--! Low-level component
entity my_low_level_component is

    port
    (

        --! Port A
        PORT_A                  : in    std_logic;

        --! Port B
        PORT_B                  : in    std_logic;

        --! Output
        PORT_Q                  : out   std_logic

    );

end my_low_level_component;


--! Implementation of the my_top_level component.
architecture rtl of my_top_level is --! \cond
begin --! \endcond


    --! Combine PORT_A and PORT_B
    U_INST_A : entity my_design_lib.my_low_level_component

        port map
        (

            -- Port A
            PORT_A                  => PORT_A,

            -- Port B
            PORT_B                  => PORT_B,

            -- Output
            PORT_Q                  => PORT_E

        );


    --! Combine PORT_C and PORT_D
    U_INST_B : entity my_design_lib.my_low_level_component

        port map
        (

            -- Port A
            PORT_A                  => PORT_C,

            -- Port B
            PORT_B                  => PORT_D,

            -- Output
            PORT_Q                  => PORT_F

        );


end architecture rtl;


--! Implementation of the my_low_level_component component.
architecture rtl of my_low_level_component is --! \cond
begin --! \endcond

    --! Combine PORT_A and PORT_B inputs to generate the module's output
    MY_SIMPLE_PROCESS : process (PORT_A, PORT_B)
    begin

        PORT_Q <= PORT_A xor PORT_B;

    end process MY_SIMPLE_PROCESS;

end;


-- End of file doxygen_example.vhdl
